; =================================================================================================
; Title:   ExcelHost.asm
; Author:  G. Friedrich
; Version: 1.0.0
; Purpose: Demonstration of ExcelHost using ObjAsm32.
; =================================================================================================


%include @Environ(OA32_PATH)\\Code\\Macros\\Model.inc       ;Include & initialize standard modules
SysSetup OOP_PRIMER, DEBUG(WND)                             ;Loads OOP files and OS related objects

IncludeBoth advapi32, ole32, oleaut32                       ;Includes these APIs

% include &MacPath&UStrings.inc                             ;UNICODE string support
% include &MacPath&BStrings.inc                             ;BSTR support
% include &COMPath&COM.inc                                  ;COM basic support
% include &COMPath&COM_Interfaces.inc                       ;COM common interfaces
% include &COMPath&OAIDL.inc
% include &COMPath&COM_Dispatch.inc                         ;Dispatch definitions and macros
% include &COMPath&COM_Dispatch.asm                         ;Dispatch procedures

.const                                                      ;Global GUIDs
DefGUID IID_NULL, %sGUID_NULL
DefGUID IID_IUnknown, %sIID_IUnknown

.data
vString     VARIANT   {}
pBook       Pointer   NULL
pSheet      Pointer   NULL
pRange      Pointer   NULL

MakeObjects ExcelHost

.code
Start:
    SysInit
    invoke CoInitialize, 0
    OCall @ExcelHost::ExcelHost.Init, NULL
    OCall @ExcelHost::ExcelHost.SetVisible, TRUE

    mov pBook, $OCall(@ExcelHost::ExcelHost.NewBook)
;    mov pSheet, $OCall(@ExcelHost::ExcelHost.GetSheet, pBook, $OfsCBStr("Table1"))
    mov pSheet, $OCall(@ExcelHost::ExcelHost.NewSheet, pBook, $OfsCBStr("My Worksheet"))

    OCall @ExcelHost::ExcelHost.GetSheetName, pSheet
    DbgUStr eax
    invoke SysFreeString, eax

    mov pRange, $OCall(@ExcelHost::ExcelHost.GetRange, pSheet, $OfsCBStr("C3:E5"))
;    OCall @ExcelHost::ExcelHost.Select, pRange

    OCall @ExcelHost::ExcelHost.SetCell, pRange, 2, 2, $OfsCBStr("Hello Excel")
    OCall @ExcelHost::ExcelHost.SetHorAlign, pRange, xlHAlignCenter
    OCall @ExcelHost::ExcelHost.SetVerAlign, pRange, xlHAlignCenter
    OCall @ExcelHost::ExcelHost.SetBorder, pRange, xlDouble, xlEdgeBottom, xlEdgeTop, xlEdgeRight, xlEdgeLeft
    OCall @ExcelHost::ExcelHost.SetInterior, pRange, $RGB(250,128,128), xlPatternLightDown, $RGB(0,0,255)
    OCall @ExcelHost::ExcelHost.SetFont, pRange, $OfsCBStr("Arial"), 20

    OCall @ExcelHost::ExcelHost.GetCell, pRange, 2, 2, addr vString, VT_BSTR
    DbgUStr vString.VARIANT.bstrVal
    invoke SysFreeString, vString.VARIANT.bstrVal
    
    OCall @ExcelHost::ExcelHost.SetColumnWidth, pSheet, $OfsCBStr("C:E"), 41A00000h     ;20
    OCall @ExcelHost::ExcelHost.SetRowHeight, pSheet, $OfsCBStr("3:5"), 42200000h       ;40

    OCall @ExcelHost::ExcelHost.SetSavedFlag, pBook, TRUE
;    OCall @ExcelHost::ExcelHost.SaveAs, pBook, $OfsCBStr("TestBook.xls")

    ICall pRange::IUnknown.Release
    ICall pSheet::IUnknown.Release
    ICall pBook::IUnknown.Release

    @invoke MessageBox, NULL, "Press OK to continue", "Pause", MB_OK
    OCall @ExcelHost::ExcelHost.Quit

    OCall @ExcelHost::ExcelHost.Done
    invoke CoUninitialize
    SysDone
    invoke ExitProcess, 0
end Start